import base64, cStringIO
import os, sys, thread, time
import wx, wx.lib.scrolledpanel

APP_NAME = "ShowChords"
VERSIONNR ="1.2"

class ShowChords(wx.Frame):
    def __init__(self, *args, **kwargs):
        # init flags
        self.size = kwargs["size"]
        self.StartPressed = False
        self.StopProgram = False
        self.interval = 0.08 # ranging from 0.01 to 0.15)
        self.fontsize = 12
        self.textlines = []
        self.maxlen = 80
        # init Frame & Panels
        wx.Frame.__init__(self, *args, **kwargs)
        self.Bind(wx.EVT_CLOSE, self.OnClose)
        myStream = cStringIO.StringIO(img)
        # img must not be greater than 32 x 32 !!
        myImage = wx.ImageFromStream(myStream)
        myBitmap = wx.BitmapFromImage(myImage)
        myIcon = wx.EmptyIcon()
        myIcon.CopyFromBitmap(myBitmap)        
        self.SetIcon(myIcon)
        self.SetTitle(APP_NAME + " " + VERSIONNR)
        self.panel = wx.Panel(self, -1)
        self.sizer=wx.BoxSizer(wx.VERTICAL)
        hsizer=wx.BoxSizer(wx.HORIZONTAL)
        self.static_text = wx.StaticText(self.panel, -1, "Title")
        self.font16bold = wx.Font(16, wx.SWISS, wx.ITALIC, wx.BOLD)
        self.static_text.SetFont(self.font16bold)
        self.sizer.Add(self.static_text, 0, wx.ALIGN_LEFT|wx.ALL, 2)
        self.LoadButton = wx.Button(self.panel, -1, label = "Laden")
        self.Bind(wx.EVT_BUTTON, self.OnLoad, self.LoadButton)
        hsizer.Add(self.LoadButton, 0, wx.ALIGN_LEFT|wx.ALL, 2)
        self.StartButton = wx.Button(self.panel, -1, label = "Start")
        self.Bind(wx.EVT_BUTTON, self.OnStart, self.StartButton)
        hsizer.Add(self.StartButton, 0, wx.ALIGN_LEFT|wx.ALL, 2)
        self.sizer.Add(hsizer, 0, wx.ALIGN_LEFT|wx.ALL, 0)
        self.sliderlabel = wx.StaticText(self.panel, -1, "  Speed:")
        hsizer.Add(self.sliderlabel, 0, wx.ALIGN_LEFT|wx.ALL, 2)
        self.slider = wx.Slider(self.panel, 8, self.interval*100, 1, 15,
        style=wx.SL_HORIZONTAL | wx.SL_LABELS )
        self.slider.SetTickFreq(1, 1)
        self.panel.Bind(wx.EVT_SLIDER, self.OnSliderUpdate)
        hsizer.Add(self.slider, 0, wx.ALIGN_LEFT|wx.ALL, 2)
        self.fontlabel = wx.StaticText(self.panel, -1, "  Font:")
        hsizer.Add(self.fontlabel, 0, wx.ALIGN_LEFT|wx.ALL, 2)
        self.fonts = [str(i) for i in range(8, 16)]
        self.fontchoicenumber = self.fonts.index(str(self.fontsize))
        self.fontchoice = wx.Choice(self.panel, self.fontchoicenumber, (200, 50), choices = self.fonts)
        self.panel.Bind(wx.EVT_CHOICE, self.OnFontChoice, self.fontchoice)
        self.fontchoice.SetSelection(self.fontchoicenumber)
        hsizer.Add(self.fontchoice, 0, wx.ALIGN_LEFT|wx.ALL, 2)
        self.scrolled_panel = wx.lib.scrolledpanel.ScrolledPanel(parent=self.panel, size=(self.size[0]-20, self.size[1]-120), id=-1)
        self.scrolled_panel.SetupScrolling()
        self.scrolled_panel.Bind(wx.EVT_SCROLLWIN, self.OnPanelScrollEvent) 
        # self.scrolled_panel.Bind(wx.EVT_KEY_DOWN, self.OnPanelKey)
        self.sizer.Add(self.scrolled_panel, wx.EXPAND, 0)
        text = ""
        self.textlines = []
        self.fontsize = 12
        self.fontnormal = wx.Font(self.fontsize, wx.MODERN, wx.NORMAL, wx.NORMAL)
        self.textlin = []
        self.panel.SetSizer(self.sizer)
        self.panel.SetAutoLayout(1)
        # print sys.argv
        if len(sys.argv)>1:
            self.filename=sys.argv[1]
            self.LoadFile()
        else:
            self.OnLoad(0)
        self.LoadButton.Disable()
        self.linecount = len(self.textlin)
        # print "self.linecount", self.linecount
        self.Show()
        self.OnFontChoice(0, fp=self.fontsize)
        self.clntsz = self.scrolled_panel.GetClientSize()
        # print self.clntsz
        self.vs_x, self.vs_y   = self.scrolled_panel.GetViewStart()
        # print self.vs_x, self.vs_y
        self.scrolled_panel.SetScrollRate(self.fontsize,1)
        thread.start_new_thread(self.Run, ())
        self.Bind(wx.EVT_SIZE, self.OnSize)
    
    def LoadFile(self):
        try:
            datei = open(self.filename, "r")
            self.textlin = datei.readlines()
            datei.close()
        except IOError:
            dlg = wx.MessageDialog(self, 'Die angegebene Datei '+filename+' wurde nicht gefunden', 'Datei nicht gefunden!?', 
                    wx.OK | wx.ICON_ERROR)
            ret = dlg.ShowModal()
            sys.exit()
        self.header = self.textlin[0].replace("\n", "")
        self.static_text.SetLabel(self.header)
        self.SetTitle(self.header + " " + APP_NAME + " " + VERSIONNR)
        self.scrollsizer=wx.BoxSizer(wx.VERTICAL)
        # del self.textlines
        self.textlines = []
        self.maxlen = 0
        for i in range(len(self.textlin)):
            line = self.textlin[i].replace("\n", "").replace("\t", "    ")
            ll = len(line)
            if ll>self.maxlen:
                self.maxlen = ll
            self.textlines.append(wx.StaticText(self.scrolled_panel, -1, line)) 
            self.textlines[-1].SetFont(self.fontnormal)
            self.scrollsizer.Add(self.textlines[-1], 0)
        # print "self.sppu_x, self.sppu_y", self.sppu_x, self.sppu_y
        winsize = self.get_winsize()
        if len(sys.argv)>1:
            self.SetSize(winsize)
            self.scrolled_panel.SetSize((winsize[0]-20, winsize[1]-120))
            self.scrolled_panel.SetSizer(self.scrollsizer)
            self.scrolled_panel.SetAutoLayout(1)
        else:
            self.scrolled_panel.SetSizer(self.scrollsizer)
            self.scrolled_panel.SetAutoLayout(1)
        # print "self.maxlen, self.fontsize", self.maxlen, self.fontsize
        self.sppu_x, self.sppu_y = self.scrolled_panel.GetScrollPixelsPerUnit()
                
    def OnClose(self, event):
        if not self.StopProgram:
            self.StopProgram = True
            time.sleep(1) # time for the thread to leave 
            self.Close()
            sys.exit()
            
    def get_winsize(self):
        c = 50
        winsize = (self.fontsize*self.maxlen+c, self.size[1])
        return winsize
            
    def OnFontChoice(self, event, fp=None):
        if fp == None:
            id = event.GetInt()
            # print id
            self.fontsize = int(self.fonts[id])
        else:
            self.fontsize = fp
        # print self.fontsize
        self.fontnormal = wx.Font(self.fontsize, wx.MODERN, wx.NORMAL, wx.NORMAL)
        for t in self.textlines:
            t.SetFont(self.fontnormal)
        winsize = self.get_winsize()
        self.SetSize(winsize)
        self.scrolled_panel.SetSize((winsize[0]-20, winsize[1]-120))
        if fp == None:
            event.Skip()
            
    def OnLoad(self, event):
        dialog = wx.FileDialog(None, "Chords", os.getcwd(), 
        "", "Text Files (*.txt)|*.txt|Chord Files (*.crd)|*.crd|All files|*", wx.OPEN)
        ret = dialog.ShowModal()
        filename = dialog.GetPath()
        if ret == wx.ID_OK and filename != "":
            self.filename = filename
            self.LoadFile()

    def OnPanelScrollEvent(self, event):
        "Action for scrolling in panel"
        eventType = event.GetEventType()
        vs_x, vs_y   = self.scrolled_panel.GetViewStart()
        # print "vs_x, vs_y", vs_x, vs_y, 
        self.clntsz = self.scrolled_panel.GetClientSize()
        # print "self.clntsz", self.clntsz
        new_vs_x, new_vs_y = vs_x, vs_y
        if event.GetOrientation() == wx.VERTICAL:
            if eventType == wx.wxEVT_SCROLLWIN_PAGEUP:
                self.i = self.i - self.clntsz.height
            elif eventType == wx.wxEVT_SCROLLWIN_PAGEDOWN:
                self.i = self.i + self.clntsz.height
            elif eventType == wx.wxEVT_SCROLLWIN_LINEUP:
                self.i = self.i - self.sppu_y
            elif eventType == wx.wxEVT_SCROLLWIN_LINEDOWN:
                self.i = self.i + self.sppu_y
            elif eventType == wx.wxEVT_SCROLLWIN_TOP:
                self.i = 0
            elif eventType == wx.wxEVT_SCROLLWIN_BOTTOM:
                self.i = self.sppu_y*self.linecount
            elif eventType == wx.wxEVT_SCROLLWIN_THUMBTRACK:
                self.i = event.GetPosition()
            elif eventType == wx.wxEVT_SCROLLWIN_THUMBRELEASE:
                self.i = event.GetPosition()
            if self.i<0:
                self.i = 0
            # print "self.i", self.i 
            new_vs_y = self.i
        else:
            if eventType == wx.wxEVT_SCROLLWIN_PAGEUP:
                new_vs_x = new_vs_x - self.clntsz.width
            elif eventType == wx.wxEVT_SCROLLWIN_PAGEDOWN:
                new_vs_x = new_vs_x + self.clntsz.width
            elif eventType == wx.wxEVT_SCROLLWIN_LINEUP:
                new_vs_x = new_vs_x - self.sppu_x
            elif eventType == wx.wxEVT_SCROLLWIN_LINEDOWN:
                new_vs_x = new_vs_x + self.sppu_x
            elif eventType == wx.wxEVT_SCROLLWIN_TOP:
                new_vs_x = 0
            elif eventType == wx.wxEVT_SCROLLWIN_BOTTOM:
                new_vs_x = self.sppu_x*self.maxlen
            elif eventType == wx.wxEVT_SCROLLWIN_THUMBTRACK:
                new_vs_x = event.GetPosition()
            elif eventType == wx.wxEVT_SCROLLWIN_THUMBRELEASE:
                new_vs_x = event.GetPosition()
            if new_vs_x<0:
                new_vs_x = 0
            self.j = new_vs_x
        if new_vs_x != vs_x or new_vs_y != vs_y:
            self.scrolled_panel.Scroll(new_vs_x, new_vs_y)
 
    def OnSize(self, event):
        (window_width, window_height) = self.GetSizeTuple()
        # print (window_width, window_height) 
        self.scrolled_panel.SetSize((window_width-20, window_height-120))
        
    def OnSliderUpdate(self, event):
        pos = self.slider.GetValue()
        self.interval = (16-pos)/100.0
        # print self.interval
        
    def OnStart(self, event):
        if self.StartPressed:
            self.StartPressed = False
            self.StartButton.SetLabel("Start")
        else:
            self.StartPressed = True
            self.StartButton.SetLabel("Stop")            
    
    def Run(self):
        self.i = -1
        self.j = 0
        while not self.StopProgram:
            if self.StartPressed:
                self.i = self.i + 1
                if self.i<self.sppu_y*self.linecount:
                    self.scrolled_panel.Scroll(self.j, self.i)
                    # print self.i,
                    self.Update()
                    time.sleep(self.interval)
                else:
                    self.i = -1
                    self.OnStart(0)    
    

note_b64 = \
"""/9j/4AAQSkZJRgABAQEAYABgAAD/2wBDAAIBAQIBAQICAgICAgICAwUDAwMDAwYEBAMFBwYH
BwcGBwcICQsJCAgKCAcHCg0KCgsMDAwMBwkODw0MDgsMDAz/2wBDAQICAgMDAwYDAwYMCAcI
DAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAwMDAz/wAAR
CAAgACADASIAAhEBAxEB/8QAHwAAAQUBAQEBAQEAAAAAAAAAAAECAwQFBgcICQoL/8QAtRAA
AgEDAwIEAwUFBAQAAAF9AQIDAAQRBRIhMUEGE1FhByJxFDKBkaEII0KxwRVS0fAkM2JyggkK
FhcYGRolJicoKSo0NTY3ODk6Q0RFRkdISUpTVFVWV1hZWmNkZWZnaGlqc3R1dnd4eXqDhIWG
h4iJipKTlJWWl5iZmqKjpKWmp6ipqrKztLW2t7i5usLDxMXGx8jJytLT1NXW19jZ2uHi4+Tl
5ufo6erx8vP09fb3+Pn6/8QAHwEAAwEBAQEBAQEBAQAAAAAAAAECAwQFBgcICQoL/8QAtREA
AgECBAQDBAcFBAQAAQJ3AAECAxEEBSExBhJBUQdhcRMiMoEIFEKRobHBCSMzUvAVYnLRChYk
NOEl8RcYGRomJygpKjU2Nzg5OkNERUZHSElKU1RVVldYWVpjZGVmZ2hpanN0dXZ3eHl6goOE
hYaHiImKkpOUlZaXmJmaoqOkpaanqKmqsrO0tba3uLm6wsPExcbHyMnK0tPU1dbX2Nna4uPk
5ebn6Onq8vP09fb3+Pn6/9oADAMBAAIRAxEAPwDzL/gnr8F9A/aM/bb+HvgXxTbz3Xh7xJLq
Ud7FBcPbysINJvruPa6EFT5tvHn1GR3r9Sx/wQ3/AGfCMnw/4l/8KG5/xr84f+CPa7/+CoXw
cX1u9ZH/AJb+qV++a6Z8vSv3rxe4izXAZ3CjgsTOnF04u0ZNK/NLWye+iPEyrD0p0W5xT17e
h8J+Gf8AgjT+zf4z0ia907Q/FElvBf32mOX126QiezvJrOcYJ6Ca3kAPcAEcEV+Y/wC338Gt
C/Z6/bH8deC/DMFxbaDoNxax2kU87TyIJLK3mbLty3zyOeexA7V+6n7M1t5vwv1U+njXxeP/
AC59Vr8WP+CuSbP+CknxWHpd2H/prs618HeIs0x+dVaONxE6kVSk7Sk2r88Feze9m/vFmuHp
Qopwik79vJk3/BHX/lKR8Gf+vzWP/Uf1Sv0q/wCCzutfttR+E/A2k/sbaN4be41O4uG8Ua5d
3GmfbtKVDD9nWKPUXEBicNOXZY5ZPkXaI8Zf8hP2Tv2g7n9k/wDaV8IfEmz0q31y58JS3csd
hPO0Ed19osLmzIMgViu0XJfhTkoBxnI+6B/wcoeKVXH/AAqLw6R/2ME//wAZr0PFHgXOs4ze
OKy6jzwVOMb80FqnJ7Skn1RGW42jSpclR2d/PyPvz9hX4OeP/gL+yR4U8NfFbxRpXjP4lRtf
6n4m1nTbVbW0vL++1C5vpvKRURdqtclNwjQNs3BE3bR+NP8AwV5/5SU/Ff8A6+9P/wDTXZ19
KT/8HIfiifr8I/Do/wC5gn/+M18O/tV/tA3H7VX7RHij4hXelQaHceJpbeV7GG4NxHbmK1ht
8Byqk5EO7kDG7HOMnTwr4GzrJs2qYrMaXJB03FPmi9XKDtaLb2TJzLG0a1JRpu7v/mf/2Q=="""
img = base64.b64decode(note_b64)

if __name__=="__main__":
    app = wx.PySimpleApp()
    my_frame=ShowChords(None, -1, size=(600, 600))
    app.MainLoop()
